#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Imaging;

using Syncfusion.Windows.Forms.Chart;

namespace ChartExportImage
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Chart.ChartControl chtReport;
		private System.Windows.Forms.Button button1;
		private string imageLocation;
		private System.Windows.Forms.StatusBar statusBar1;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.chtReport = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.button1 = new System.Windows.Forms.Button();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.SuspendLayout();
			// 
			// chtReport
			// 
			this.chtReport.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.chtReport.Legend});
			// 
			// chtReport.Legend
			// 
			this.chtReport.Location = new System.Drawing.Point(24, 16);
			this.chtReport.Name = "chtReport";
			this.chtReport.Size = new System.Drawing.Size(504, 264);
			this.chtReport.TabIndex = 0;
			this.chtReport.Text = "chtReport";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(24, 328);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(136, 24);
			this.button1.TabIndex = 1;
			this.button1.Text = "Export Image";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 352);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(552, 22);
			this.statusBar1.SizingGrip = false;
			this.statusBar1.TabIndex = 5;
			this.statusBar1.Text = "Ready";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 374);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.statusBar1,
																		  this.button1,
																		  this.chtReport});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "Form1";
			this.Text = "Essential Chart - Export as Image";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			InitializeChartData();

			this.chtReport.Legend.ShowBorder = false;
			this.chtReport.Legend.Visible = false;

		}

		protected void InitializeChartData()
		{
			int numSeries = 1;
			int numPoints = 5;

			Random random = new Random();
			for(int i = 0; i < numSeries; i++)
			{
				ChartSeries series = this.chtReport.Model.NewSeries("Series " + i);
				for(int j = 0; j < numPoints; j++)
				{
					double points = random.Next(100, 200);
					series.Points.Add(j+1, points);
				}
				
				series.Type = ChartSeriesType.Column;
				series.Text = series.Name;
				this.chtReport.Series.Add(series);
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			SaveAs();
		}

		public void SaveAs()
		{
			SaveFileDialog pSaveFileDialog = new SaveFileDialog();
			pSaveFileDialog.DefaultExt="*.bmp";
			pSaveFileDialog.Filter = "BMP(*.bmp)|*.bmp|JPG(*.JPG)|*.JPG|WMF(*.WMF)|*.WMF|GIF(*.GIF)|*.Gif|Tiff(*.tif)|*.TIF|PNG(*.Png)|*.Png|Icon(*.ico)|*.ico";
			pSaveFileDialog.Title = "Save As ";
			pSaveFileDialog.FileName="Untitled";
			if (pSaveFileDialog.ShowDialog()==DialogResult.OK)
			{
				Image bitmap = new Bitmap(chtReport.ClientSize.Width, chtReport.ClientSize.Height);
				chtReport.Draw(bitmap);
				string sExt=System.IO.Path.GetExtension(pSaveFileDialog.FileName).ToLower();
				switch (sExt)
				{
					case ".jpg":
						bitmap.Save(pSaveFileDialog.FileName, ImageFormat.Jpeg);
						break;
					case ".bmp":
						bitmap.Save(pSaveFileDialog.FileName, ImageFormat.Bmp);
						break;

					case ".wmf":
						bitmap.Save(pSaveFileDialog.FileName, ImageFormat.Wmf);
						break;
					case ".gif":
						bitmap.Save(pSaveFileDialog.FileName, ImageFormat.Gif);
						break;
					case ".tif":
						bitmap.Save(pSaveFileDialog.FileName, ImageFormat.Tiff);
						break;
					case ".png":
						bitmap.Save(pSaveFileDialog.FileName, ImageFormat.Png);
						break;
					case ".ico":
						bitmap.Save(pSaveFileDialog.FileName, ImageFormat.Icon);
						break;

				}
				bitmap.Dispose();

				string sMsg="The graph has been saved to the file " +pSaveFileDialog.FileName+ "\r\n" +"Do you want to open it now?";
				DialogResult pDialogResult=MessageBox.Show(sMsg,"Test",MessageBoxButtons.YesNo,MessageBoxIcon.Question);
				if (pDialogResult==DialogResult.Yes)
				{
					System.Diagnostics.Process.Start(pSaveFileDialog.FileName);
				}

			}
		}

	}
}
